<?php

namespace Smilepay\Smilepayc2cup\Controller\Emap;

class SaveEmap extends \Magento\Framework\App\Action\Action
{
    protected $_checkoutSession;
    protected $_orderFactory;
    protected $_smilepayc2cup_session;
    protected $_smilepayc2cup_shippingmethod;
    protected $_smilepayc2cup_helper_data;
    protected $_resultPageFactory;
    protected $_urlInterface;
    protected $_objectManager;
    
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayc2cup\Model\Session $smilepayc2cup_session,
        \Smilepay\Smilepayc2cup\Model\Shippingmethod $smilepayc2cup_shippingmethod,
        \Smilepay\Smilepayc2cup\Helper\Data   $smilepayc2cup_helper_data,
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Magento\Framework\UrlInterface $urlInterface
       
    ) {
        $this->_checkoutSession = $checkoutSession;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cup_session = $smilepayc2cup_session;
        $this->_smilepayc2cup_shippingmethod = $smilepayc2cup_shippingmethod;
        $this->_smilepayc2cup_helper_data=$smilepayc2cup_helper_data;
        $this->_resultPageFactory = $resultPageFactory;
        $this->_urlInterface = $urlInterface;
        $this->_objectManager = $objectManager;
        
        parent::__construct($context);


    }

    public function execute()
    {
        $resultPage = $this->_resultPageFactory->create();
        $session= $this->getSession();

        $emapdata = array(
                    'Storeid' => $_REQUEST['storeid'],
                    'Storename' => $_REQUEST['storename'],
                    'Storeaddress' => $_REQUEST['storeaddress']
                        );

        $smilepayc2cup_model=$this->_smilepayc2cup_shippingmethod;
        if( isset ($emapdata))
        {
            $session->setSmilepayc2cupMapResult($emapdata);
        }
        else
        {
            $emapdata=$session->getSmilepayc2cupMapResult();
        }
        $this->_redirect('checkout/');
        return $resultPage;
    }


    /*
    public function saveEmapAction()
    {
        $session= $this->getSession();

        $emapdata = array(
                    'Storeid' => $_REQUEST['storeid'],
                    'Storename' => $_REQUEST['storename'],
                    'Storeaddress' => $_REQUEST['storeaddress']
                        );

        $smilepayc2cup_model=Mage::getSingleton('smilepayc2cup/shippingmethod');
        if( isset ($emapdata))
        {
            $session->setSmilepayc2cupMapResult($emapdata);
        }
        else
        {
            $emapdata=$session->getSmilepayc2cupMapResult();
        }

        $this->loadLayout();
        $layout = $this->getLayout();
        $block = $layout->createBlock('Mage_Core_Block_Template','smilepayc2cup_emap_result',array('template' => 'smilepayc2cup/checkout/shipping/emapreturn.phtml'));

        $block->assign(
                        array(
                            'smilepay_c2cup_title' =>   $smilepayc2cup_model->getConfigData('name'),
                            //'smilepay_c2cup_status' =>  $emapdata['Status'],
                            'smilepay_c2cup_storename' =>$emapdata['Storename'],
                            'smilepay_c2cup_storeaddress' => $emapdata['Storeaddress'],
                        //    'smilepay_c2cup_amount' => $smilepayc2cup_result['Amount'],
                            'smilepay_c2cup_storeid' => $emapdata['Storeid'],
                            'smilepay_c2cup_map_url' => $smilepayc2cup_model->getEMapUrl(),
                            //'smilepay_c2cup_pur_name' => $smilepayc2cup_result['Pur_name'],
                            //'smilepay_c2cup_data_id' => $smilepayc2cup_result['Data_id'],
                           // 'smilepay_c2cup_mobile_number' => $smilepayc2cup_result['Mobile_number'],
                             )
                    );
        $layout->getBlock('content')->append($block);

        $this->renderLayout();
    }
    */
 
    
    function getSession()
    {
        return $this->_smilepayc2cup_session;
    }



}

?>