<?php
namespace  Smilepay\Smilepayc2cup\Model;
use Magento\Quote\Model\Quote\Address\RateRequest;
use Magento\Shipping\Model\Carrier\AbstractCarrier;
use Magento\Shipping\Model\Carrier\CarrierInterface;
use Magento\Shipping\Model\Rate\Result;




class Shippingmethod
extends \Magento\Shipping\Model\Carrier\AbstractCarrier
implements \Magento\Shipping\Model\Carrier\CarrierInterface
{
  protected $_code = 'smilepayc2cup';
  protected $smseurl = 'http://ssl.smse.com.tw/api/sppayment.asp';
  protected $emap_url = 'https://emap.presco.com.tw/c2cemap.ashx';
  protected $_isFixed = true;  


  protected $_rateResultFactory;

  protected $_rateMethodFactory;
  protected $_storeManager;
  protected $_urlInterface;
  protected  $_smilepayc2cup_session;
  protected $_orderFactory;
  protected $_smilepayc2cup_helper_data;
  protected $_action_context;
  protected $generatorPool;
  public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Quote\Model\Quote\Address\RateResult\ErrorFactory $rateErrorFactory,
        \Psr\Log\LoggerInterface $logger,
        \Magento\Shipping\Model\Rate\ResultFactory $rateResultFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Sales\Model\Order $orderFactory,
        \Magento\Framework\UrlInterface $urlInterface,
        \Magento\Quote\Model\Quote\Address\RateResult\MethodFactory $rateMethodFactory,
        \Smilepay\Smilepayc2cup\Model\Session $smilepayc2cup_session,
        \Smilepay\Smilepayc2cup\Helper\Data   $smilepayc2cup_helper_data,
        \Magento\Framework\View\Layout\GeneratorPool  $generatorPool,
        \Magento\Framework\App\Action\Context $action_context,
        array $data = []
    ) {
        $this->_rateResultFactory = $rateResultFactory;
        $this->_rateMethodFactory = $rateMethodFactory;
        $this->_storeManager=$storeManager;
        $this->_urlInterface = $urlInterface;
        $this->_smilepayc2cup_session = $smilepayc2cup_session;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayc2cup_helper_data =  $smilepayc2cup_helper_data;
        $this->_action_context = $action_context;

        $this->generatorPool = $generatorPool;


        //map mobile start
        $useragent=$_SERVER['HTTP_USER_AGENT'];
        if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
        {
            //pc
            $this->emap_url = "https://emap.presco.com.tw/c2cemap.ashx";
        }
        else
        {
            $this->emap_url = "https://emap.presco.com.tw/c2cemapm-u.ashx";
        }
        //map mobile end



        parent::__construct($scopeConfig, $rateErrorFactory, $logger, $data);

   }





  public function getMaxOrderTotal()
  {
    return $this->getConfigData('max_order_total');
  }
  public function getMinOrderTotal()
  {
    return $this->getConfigData('min_order_total');
  }

  public function getCurrencyLimit()
  {
    return trim($this->getConfigData('smilepay_c2cup_currency_limit'));
  }
  public function isActive()
  {
    $result=parent::isActive();
    if( $result)
    {
        if($this->getCurrencyLimit()==true)
        {
            if($this->_storeManager->getStore()->getCurrentCurrencyCode() != 'TWD')
                return false;
        }

    }
    return $result;
  }
  
  public function collectRates(RateRequest $request)
  {
    if (!$this->isActive()) 
    {
            return false;
    }
    //check total
    $total = $request->getBaseSubtotalInclTax()+$this->getConfigData('price');
    $minTotal = $this->getConfigData('min_order_total');
    $maxTotal = $this->getConfigData('max_order_total');
    if ((!empty($minTotal) && ($total < $minTotal)) || (!empty($maxTotal) && ($total > $maxTotal))) {
            return false;
        }

    $result = $this->_rateResultFactory->create();

    $this->_updateFreeMethodQuote($request);

    $result->append($this->_getDefaultRate($request));
 
    return $result;
  }
 
  public function getAllowedMethods()
  {
    return array(
      'smilepayc2cup' => $this->getConfigData('name'),
    );
  }
  
  protected function _getDefaultRate($request)
  {
    $rate = $this->_rateMethodFactory->create();
    
    $rate->setCarrier($this->_code);
    $rate->setCarrierTitle($this->getConfigData('title'));
    $rate->setMethod($this->_code);
    $rate->setMethodTitle($this->getConfigData('name'));
    $rate->setPrice($this->getConfigData('price'));
    $rate->setCost(0);

    //free cost over specfic total
    if ($request->getFreeShipping() 
            ||( $this->getConfigData('free_shipping_enable') == 1 
            && !is_null( $this->getConfigData('free_shipping_subtotal'))
            && !empty($this->getConfigData('free_shipping_subtotal'))
            && $request->getBaseSubtotalInclTax() >= $this->getConfigData('free_shipping_subtotal'))
       )
    {
        $rate->setCost(0);
        $rate->setPrice(0.00);
    }

    return $rate;
  }

  public function getTitle()
  {
    return $this->getConfigData('title');
  }
  public function getName()
  {
    return  $this->getConfigData('name');
  }
  // E-Map URL
  public function getEMapUrl()
  {
    return $this->emap_url."?type=eshopid=870&servicetype=1&url=".$this->_urlInterface->getBaseUrl()."smilepayc2cup/emap/saveEmap";
  }
  
  public function getDcvc()
  {
    return trim($this->getConfigData('smilepay_c2cup_dcvc'));
  }
  public function getVkey()
  {
    return trim($this->getConfigData('smilepay_c2cup_vkey'));
  }
  public function getRvg2c()
  {
    return trim($this->getConfigData('smilepay_c2cup_Rvg2c'));
  }
  public function getC2CupStoreData()
  {
      $session= $this->_smilepayc2cup_session;

      return $session->getSmilepayc2cupMapResult();

  }
  public function getC2CupStoreAddress()
  {
     
      $result = $this->getC2CupStoreData();
      return  $result['Storeaddress'];
  }
  public function getC2CupStoreId()
  {
      $result = $this->getC2CupStoreData();
      return  $result['Storeid'];
  }
  public function getC2CupStoreName()
  {
      $result = $this->getC2CupStoreData();
      return  $result['Storename'];
  }
  //E-Map selected
  public function isEmapSelected()
  {
      $result = $this->getC2CupStoreData();
      $selected = true;

      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
      }
     
      return  $selected;
  }

  public function validate()
  {
       //parent::validate();

       $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
       $session  =  $objectManager->create('\Magento\Checkout\Model\Session');

       $quote_id = $session->getQuoteId();
       $quote = $objectManager->create('\Magento\Quote\Model\Quote');
       $quote->load($quote_id );

       $shippingaddress = $quote->getShippingAddress();

       $name = $shippingaddress->getLastname() . $shippingaddress->getFirstname();
       $telephone = $shippingaddress->getTelephone();


       if( !preg_match("/[^a-zA-Z0-9 ]/",$name))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cup_vaildate_smse_config_error");
       }


       if(mb_strlen($name,"utf-8") > $limit_name_number )
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cup_validate_name_error");
       }
       elseif( !preg_match("/^[0][9][0-9]{8,8}\$/", $telephone ))
       {
           $errorCode = 'invalid_data';
           $errorMsg = __("smilepay_c2cup_validate_phone_error");
       }
       elseif(!$this->isEmapSelected())
       {
           $errorMsg = __("smilepay_c2cup_vaildate_emap_selected_error");
       }

     
       
       if ($errorMsg) 
            return $errorMsg;
       else
            return true;
  }

  //Description: Connect to SMSe create c2cup order
  //return: SMSe result array return when success,
  //return: error array when fail,
  public function runC2CupProcess($order_increment_id)
  {
      if(!isset($order_increment_id))
      {
          $error['Status']='-1';
          $error['Desc']='Error Order id, input error!';
          return $error;
      }
      
      $order_id=$order_increment_id;

      $order= $this->_orderFactory->loadByIncrementId($order_id);

      if (!$order->getId()) 
      {
          $error['Status']='-2';
          $error['Desc']='Error Order id, NOT find!';
          return $error;
      }
      if(!$this->isEmapSelected())
      {
          $error['Status']='-3';
          $error['Desc']= __("smilepay_c2cup_vaildate_emap_selected_order_check_error");
          return $error;
      }
      
      $customer_name =  $order->getShippingAddress()->getLastname() . $order->getShippingAddress()->getFirstname();
      $customer_email=$order->getCustomerEmail();
      $phone = $order->getShippingAddress()->getTelephone();
      $shippingAddress=$order->getShippingAddress();
      $address=  $shippingAddress->getData('region') . " " . $shippingAddress->getData('city') ." " .  $shippingAddress->getData('street');
          
      $c2cStoreData = sprintf('%s/%s/%s',$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());

      $session= $this->_smilepayc2cup_session;
      $result=$session->getC2CSMSeData();

      if( $result['Data_id']==$order_id)
      {
          //have placed
          $error['Status']='-4';
          $error['Desc']=__("smilepay_c2cup_place_order_again_error");
          $error['place_order']= 1;
          return $error;
      }
      if($this->getCurrencyLimit()==true)
      {
          $total = $order->getGrandTotal();
      }
      else
      {
            //find TWD selected?
          if($this->_smilepayc2cup_helper_data->isCurrencyTWDselected())
              $total = $order->getGrandTotal();
          else
              $total = $order->getBaseGrandTotal();
      }

      $postdata = array(
                        'Dcvc' =>trim( $this->getDcvc()),
                        'Rvg2c' => trim($this->getRvg2c()),
                        'Verify_key' =>trim($this->getVkey()),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $order_id,
                        'Pay_zg' => 52,
                        'Pay_subzg'=> '7NET',
                        'Data_id' => $order_id,
                        'Amount' => intval(round($total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Logistics_store' =>$c2cStoreData,
                        //'Roturl' => Mage::getUrl("smilepayc2cup/smilepayc2cup/paid") ,
                        //'MapRoturl' =>Mage::getUrl("smilepayc2cup/smilepayc2cup/mapreturn") ,
                        //'Roturl_status'=>'magento1.8.1_Ok',
                    );

        //connection start
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$this->smseurl);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
        $resultxml=curl_exec($ch); 
        curl_close($ch);


        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                (strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    'PayEndDate' =>urldecode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                 );   
    
            }
            else
            {
                 $result = array(
                            'Status' => '-1000',
                            'Desc' => '取號失敗',    
                            'Data_id'=>$order_id,
                        );     
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$order_id,
                    );     
        }
        $Smseid = $result['SmilePayNO'];
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        //$emailSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderSender');
        $emailCommentSender = $objectManager->create('\Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');

           


        if($result['Status']==1) // success
        {
            $result['Storename'] = $this->getC2CupStoreName();
            $result['Storeaddress'] = $this->getC2CupStoreAddress();
            $result['Storeid'] = $this->getC2CupStoreId();
            $result['Pur_name'] = $customer_name;
            $result['Mobile_number'] = $phone;

            
            $c2curl = sprintf('http://ssl.smse.com.tw/api/c2cpaymentU.asp?smseid=%s&dcvc=%s&types=web&Verify_key=%s', $Smseid,trim( $this->getDcvc()),trim($this->getVkey()));
            $admincomment=sprintf(__('smilepay_c2cup_placeorder_comment_admin_success'),$result['SmilePayNO'],$result['Pur_name'],$result['Mobile_number'],$this->getTitle(),$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());
            $customercomment=sprintf(__('smilepay_c2cup_placeorder_comment_customer_success'),$this->getTitle(),$result['Pur_name'],$result['Mobile_number'],$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());
            //note
            $order->addStatusHistoryComment( $admincomment,false);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);

            $order->save();
           // $order->sendOrderUpdateEmail(true, $customercomment);
            $emailCommentSender->send($order,true, $customercomment);
            //db
            $resource = $objectManager->create('Magento\Framework\App\ResourceConnection');
            
            $db_write= $resource->getConnection();
            
            $db_write->insert($resource->getTableName('smilepayc2cup_record'),
                                     array("order_increment_id" =>  $result['Data_id'],
                                           "smse_id" => $Smseid,
                                           "record_url"=> $c2curl,
                                           )
                            );
            $db_write->closeConnection();

        }
        else  //fail
        {
            $admincomment=sprintf(__('smilepay_c2cup_placeorder_comment_admin_fail'),$this->getTitle(),$result['Status'],$result['Desc']);
            $customercomment=sprintf(__('smilepay_c2cup_placeorder_comment_customer_fail'),$this->getTitle());
            //note
            $order->addStatusHistoryComment( $admincomment,false);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();
            $emailCommentSender->send($order,true, $customercomment);
            //$order->sendOrderUpdateEmail(true, $customercomment);
        }
        $session->setC2CSMSeData($result);
        
        return $result;

  }

  //Description: Connect to SMSe create c2cup order and clear session.
  //return: SMSe result array return when success,
  //return: error array when fail,
  public function runC2CupProcessAndClear($order_increment_id)
  {
      $result=$this->runC2CupProcess();
      $session= $this->_smilepayc2cup_session;
      $session->clear();
      return $result;
  }

  //Description: Generate C2Cup Order Block that show order result.
  //input smsedata: the data is got from  runC2CupProcess or  runC2CupProcessAndClear. 
  //                If it is null, it will get data from session 
  //return: block data
  public function generateC2CupOrderBlock($smsedata)
  {
        $controlleraction =$this->_action_context->getView();
          //run process

          //layout
        //$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayc2cup_message',array('template' => 'smilepayc2cup/placeorder/success.phtml'));
      
      
      
        $blockGenerator = $this->generatorPool->getGenerator(\Magento\Framework\View\Layout\Generator\Block::TYPE);
        $block = $blockGenerator->createBlock('Magento\Framework\View\Element\Template','smilepayc2cup_message');
      
        //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayc2cup_message');  
        $block->setTemplate('Smilepay_Smilepayc2cup::placeorder/success.phtml');
        $session= $this->_smilepayc2cup_session;

        $smilepayc2cup_result=$smsedata;

        // find session
        if(!isset($smilepayc2cup_result)|| empty($smilepayc2cup_result))
        {
            $session= $this->_smilepayc2cup_session;
            $smilepayc2cup_result =  $session->getC2CSMSeData();
        }

         
        $block->assign(
                        array(
                            'smilepay_c2cup_title' =>   $this->getTitle(),
                            'smilepay_c2cup_status' =>  $smilepayc2cup_result['Status'],
                            'smilepay_c2cup_storename' =>$smilepayc2cup_result['Storename'],
                            'smilepay_c2cup_storeaddress' => $smilepayc2cup_result['Storeaddress'],
                            'smilepay_c2cup_amount' => $smilepayc2cup_result['Amount'],
                            'smilepay_c2cup_storeid' => $smilepayc2cup_result['Storeid'],
                            'smilepay_c2cup_pur_name' => $smilepayc2cup_result['Pur_name'],
                            'smilepay_c2cup_data_id' => $smilepayc2cup_result['Data_id'],
                            'smilepay_c2cup_mobile_number' => $smilepayc2cup_result['Mobile_number'],
                             )
                    );



        return $block;
        
  }



}
?>