define(
    [
         'Magento_Checkout/js/model/quote',
    ],
    function (quote) {
        "use strict";
        return {
            
            isSmilepayc2cupSelected: function () {
                if(quote.shippingMethod() )
                {
                    var selected_shipping_code =  quote.shippingMethod().carrier_code + '_' + quote.shippingMethod().method_code;
                      
                    if(selected_shipping_code == 'smilepayc2cup_smilepayc2cup')
                        return true;
                    else
                        return false;
                }
                       
            },
            getSmilepayc2cupBlock: function(){
                return window.checkoutConfig.shipping.block['smilepayc2cup'];
            },
            getSmilepayc2cupStoreData: function(){
            
                return { "StoreId":window.checkoutConfig.shipping.data.smilepayc2cup.storeId,
                   "StoreName": window.checkoutConfig.shipping.data.smilepayc2cup.storeName,
                   "StoreAddr": window.checkoutConfig.shipping.data.smilepayc2cup.storeAddr,
                    };
            },

            getSmilepayc2cupStoreSelected: function(){ 
                return window.checkoutConfig.shipping.data.smilepayc2cup.selected;        
            },
            isSmilepayc2cupPaymentSelected: function()
            {
            
                var method = quote.paymentMethod();
                var method_code = quote.paymentMethod().method;

                if(method_code != "smilepayc2cp")
                    return true;
                else
                    return false;
            },

            isSmilepayc2cupCustomerNameValid: function()
            {
                var shippingAddr= quote.shippingAddress();
              
                var name = shippingAddr.lastname + shippingAddr.firstname;
                var maxlen = 10;
                if(!name.match(/^[a-zA-Z0-9\s]+$/))
                {
                    maxlen = 5;
                }
                if(name.length > maxlen)
                {
                    return false;
                }else
                    return true;
                
            },
            isSmilepayc2cupCustomerPhoneValid: function()
            {
                var shippingAddr= quote.shippingAddress();
                var re=/^[0][9][0-9]{8,8}$/;
                var phone = shippingAddr.telephone;
                
                if(!phone.match(re))
                {
                   return false;
                }
              
                return true;
            }

         };
    }
);
