<?php
    
namespace Smilepay\Smilepaycsv\Block\Frontend;


class Orderinfo extends \Magento\Framework\View\Element\Template {
    
    protected $order;
    
    protected $_coreRegistry = null;
    protected $_smilepaycsv_paymentmethod;
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
         \Smilepay\Smilepaycsv\Model\Paymentmethod $smilepaycsv_paymentmethod,
        array $data = []
    ) {
        $this->_coreRegistry = $registry;
        $this->_smilepaycsv_paymentmethod = $smilepaycsv_paymentmethod;
        $order=$this->getOrder();
        parent::__construct($context, $data);

        $this->setTemplate("Smilepay_Smilepaycsv::orderinfo/billgeninfo.phtml");
    }
   
  
    public function getOrder() 
    {
       if ($this->hasOrder()) {
            return $this->getData('order');
        }
        if ($this->_coreRegistry->registry('current_order')) {
            return $this->_coreRegistry->registry('current_order');
        }
        if ($this->_coreRegistry->registry('order')) {
            return $this->_coreRegistry->registry('order');
        }
    }
    public function getPaymentMethod()
    {
       $order=$this->getOrder();
       return  $order->getPayment()->getMethodInstance()->getCode();
    } 
    public function getPaymentTitle()
    {
       
       return $this->_smilepaycsv_paymentmethod->getTitle();
    }

    //when order state doesn't match,Not output
    public function isShowedBill()
    {
       $order=$this->getOrder();
       $state=$order->getStatus();

       $payment_model=$this->_smilepaycsv_paymentmethod;
     

       if($this->getPaymentMethod()!='smilepaycsv')
         return false;
      // elseif($state==$payment_model->getOrderStatus())
         //return true;
       
       return true;
    }
    public function getVCode()
    {
       $order=$this->getOrder();
       return   $this->_smilepaycsv_paymentmethod->getBarcode1($order->getIncrementId());
    }


    /*public function getShippingMethod() 
    {
       $order=$this->getOrder();
     //  $quote_id=$order->getQuoteId();
       //$quote= Mage::getSingleton('sales/quote')->load( $quote_id);

       return  $order->getShippingMethod();
 
    }
    */
  /*  public function getC2COrderData() 
    {
       $order=$this->getOrder();
       $db_read = Mage::getSingleton('core/resource')->getConnection('core_read'); 
       $tableName = Mage::getSingleton('core/resource')->getTableName('smilepayc2cp_record');
      
       $results = $db_read->fetchAll("select smse_id,record_url from $tableName where order_increment_id=" .$order->getIncrementId());
      
       return $results;
    }*/
}
?>