<?php
namespace Smilepay\Smilepaycsv\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepaycsv_session;
    protected $_smilepaycsv_paymentmethod;
    protected $_smilepaycsv_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepaycsv\Model\Session $smilepaycsv_session,
        \Smilepay\Smilepaycsv\Model\Paymentmethod $smilepaycsv_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepaycsv\Helper\Data   $smilepaycsv_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepaycsv_session = $smilepaycsv_session;
        $this->_smilepaycsv_paymentmethod = $smilepaycsv_paymentmethod;
        $this->_smilepaycsv_helper_data=$smilepaycsv_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);

      $paymentmethod = $order->getPayment()->getMethod();

      if( trim($paymentmethod) == 'smilepaycsv')
      {
          $controlleraction = $this->_context->getView();


          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepaycsv_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepaycsv::placeorder/success.phtml')
                                                                                                                         ));*/

          //$block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepaycsv_message','order.success.additional.info');  
          $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepaycsv_message','content'); 
          $block->setTemplate('Smilepay_Smilepaycsv::placeorder/success.phtml');
          $session= $this->_smilepaycsv_session;
          $smilepaycsv_result=$session->getSmilepaycsvResult();
          $smilepaycsv_model= $this->_smilepaycsv_paymentmethod;


       

          $block->assign(
                        array(
                            'smilepay_csv_title' =>   $smilepaycsv_model->getTitle(),
                            'smilepay_csv_data_id' =>  $smilepaycsv_result['Data_id'],
                            'smilepay_csv_status' =>  $smilepaycsv_result['Status'],
                            'smilepay_csv_code1' =>  $smilepaycsv_result['Barcode1'],
                             )
                    );
          $session->clearStorage();
     
          $controlleraction->getLayout()->reorderChild("content",'smilepaycsv_message','checkout.success',false);

      
      //    $controlleraction->getLayout()->getBlock('checkout.success')->insert($block,'',false);
     
      }
    
  }
}


?>