<?php
namespace Smilepay\Smilepaycsv\Setup;

class InstallSchema implements \Magento\Framework\Setup\InstallSchemaInterface
{
    public function install(\Magento\Framework\Setup\SchemaSetupInterface $setup, \Magento\Framework\Setup\ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $tableName = $installer->getTable('smilepaycsv_record');
        if ($installer->getConnection()->isTableExists($tableName) != true) {
                $table = $installer->getConnection()->newTable($tableName)  ->addColumn('record_id', \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, null, array(
                                            'identity'  => true,
                                            'unsigned'  => true,
                                            'nullable'  => false,
                                            'primary'   => true,
                                            ), 'smilepaycsv record id')
                   ->addColumn('order_increment_id',   \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 50, array(
                                            ), 'smilepaycsv order_increment_id')
                   ->addColumn('smse_id',   \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 50, array(
                                            ), 'smse_id')
                   ->addColumn('barcode1',   \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 30, array(
                                            ), 'smilepaycsv barcode1')
                   ->addColumn('barcode2',   \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 30, array(
                                            ), 'smilepaycsv  barcode2')
                   ->addColumn('barcode3',   \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 30, array(
                                            ), 'smilepaycsv  barcode3')
                   ->addColumn('dateline',   \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME, null, array(
                                            ), 'smilepaycsv dateline')
                   ->setComment('SmilePay CSV record');

                    $installer->getConnection()->createTable($table);

        }
       

        
        $installer->endSetup();
    }
}