<?php
namespace Smilepay\Smilepayfami\Observer;

use Magento\Framework\Event\ObserverInterface;
    use Magento\Framework\DataObject;
use Magento\Payment\Model\InfoInterface;
use Magento\Payment\Model\MethodInterface;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Sales\Model\Order\Invoice;
use Magento\Sales\Model\Order\Payment;
use Magento\Quote\Api\Data\PaymentMethodInterface;


class PlaceOrderSuccess  implements ObserverInterface
{
    protected $_storeManager;
    protected $_orderFactory;
    protected $_smilepayfami_session;
    protected $_smilepayfami_paymentmethod;
    protected $_smilepayfami_helper_data;
    protected $_context;
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Sales\Model\Order $orderFactory,
        \Smilepay\Smilepayfami\Model\Session $smilepayfami_session,
        \Smilepay\Smilepayfami\Model\Paymentmethod $smilepayfami_paymentmethod,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Smilepay\Smilepayfami\Helper\Data   $smilepayfami_helper_data)
    {
        $this->_storeManager = $storeManager;
        $this->_orderFactory = $orderFactory;
        $this->_smilepayfami_session = $smilepayfami_session;
        $this->_smilepayfami_paymentmethod = $smilepayfami_paymentmethod;
        $this->_smilepayfami_helper_data=$smilepayfami_helper_data;
        $this->_context =$context;
    }

  //generate order info to checkout success
  public function execute(\Magento\Framework\Event\Observer $observer)
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order =$this->_orderFactory;
      $order->load($order_id);

      $paymentmethod = $order->getPayment()->getMethod();

      if( trim($paymentmethod) == 'smilepayfami')
      {
          $controlleraction = $this->_context->getView();


          /*$block = $controlleraction->getLayout()->createBlock('Magento\Framework\View\Element\Template','smilepayfami_message',
                                                                                                                        array('data'=> 
                                                                                                                                array('template' => 'Smilepay_Smilepayfami::placeorder/success.phtml')
                                                                                                                         ));*/

         // $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayfami_message','order.success.additional.info');  
          $block =$controlleraction->getLayout()->addBlock('Magento\Framework\View\Element\Template','smilepayfami_message','content');
          $block->setTemplate('Smilepay_Smilepayfami::placeorder/success.phtml');
          $session= $this->_smilepayfami_session;
          $smilepayfami_result=$session->getSmilepayfamiResult();
          $smilepayfami_model= $this->_smilepayfami_paymentmethod;


       

          $block->assign(
                        array(
                            'smilepay_fami_title' =>   $smilepayfami_model->getTitle(),
                            'smilepay_fami_status' =>  $smilepayfami_result['Status'],
                            'smilepay_fami_fami_no' =>$smilepayfami_result['FamiNO'],
                            'smilepay_fami_amount' => $smilepayfami_result['Amount'],
                            'smilepay_fami_dateline' => $smilepayfami_result['PayEndDate'],
                             )
                    );
          $session->clearStorage();
     
          $controlleraction->getLayout()->reorderChild("content",'smilepayfami_message','checkout.success',false);

      
      //    $controlleraction->getLayout()->getBlock('checkout.success')->insert($block,'',false);
     
      }
    
  }
}


?>